pidgin: prefs.h File Reference

pidgin 2.14.4

Loading...
Searching...
No Matches
Data Structures | Typedefs | Enumerations
prefs.h File Reference
libpurple

Prefs API. More...

`#include <glib.h>`

Go to the source code of this file.

## Data Structures
struct | _PurplePrefsUiOps
| Prefs UI operations. More...

## Typedefs
typedef enum _PurplePrefType | PurplePrefType
| Preference data types.
typedef void(* | PurplePrefCallback) (const char *name, PurplePrefType type, gconstpointer val, gpointer data)
| The type of callbacks for preference changes.
typedef struct _PurplePrefCallbackData | PurplePrefCallbackData
| Opaque type to carry callback information.
typedef struct _PurplePrefsUiOps | PurplePrefsUiOps
| Prefs UI operations.

## Enumerations
enum | _PurplePrefType { PURPLE_PREF_NONE , PURPLE_PREF_BOOLEAN , PURPLE_PREF_INT , PURPLE_PREF_STRING , PURPLE_PREF_STRING_LIST , PURPLE_PREF_PATH , PURPLE_PREF_PATH_LIST }
| Preference data types. More...

## Functions
UI Registration Functions <br>
void | purple_prefs_set_ui_ops (PurplePrefsUiOps *ops)
| Sets the UI operations structure to be used for preferences.
PurplePrefsUiOps * | purple_prefs_get_ui_ops (void)
| Returns the UI operations structure used for preferences.
Prefs API
Preferences are named according to a directory-like structure. Example: "/plugins/core/potato/is_from_idaho" (probably a boolean)
void * | purple_prefs_get_handle (void)
| Returns the prefs subsystem handle.
void | purple_prefs_init (void)
| Initialize core prefs.
void | purple_prefs_uninit (void)
| Uninitializes the prefs subsystem.
void | purple_prefs_add_none (const char *name)
| Add a new typeless pref.
void | purple_prefs_add_bool (const char *name, gboolean value)
| Add a new boolean pref.
void | purple_prefs_add_int (const char *name, int value)
| Add a new integer pref.
void | purple_prefs_add_string (const char *name, const char *value)
| Add a new string pref.
void | purple_prefs_add_string_list (const char *name, GList *value)
| Add a new string list pref.
void | purple_prefs_add_path (const char *name, const char *value)
| Add a new path pref.
void | purple_prefs_add_path_list (const char *name, GList *value)
| Add a new path list pref.
void | purple_prefs_remove (const char *name)
| Remove a pref.
void | purple_prefs_rename (const char *oldname, const char *newname)
| Rename a pref.
void | purple_prefs_rename_boolean_toggle (const char *oldname, const char *newname)
| Rename a boolean pref, toggling it's value.
void | purple_prefs_destroy (void)
| Remove all prefs.
void | purple_prefs_set_generic (const char *name, gpointer value)
| Set raw pref value.
void | purple_prefs_set_bool (const char *name, gboolean value)
| Set boolean pref value.
void | purple_prefs_set_int (const char *name, int value)
| Set integer pref value.
void | purple_prefs_set_string (const char *name, const char *value)
| Set string pref value.
void | purple_prefs_set_string_list (const char *name, GList *value)
| Set string list pref value.
void | purple_prefs_set_path (const char *name, const char *value)
| Set path pref value.
void | purple_prefs_set_path_list (const char *name, GList *value)
| Set path list pref value.
gboolean | purple_prefs_exists (const char *name)
| Check if a pref exists.
PurplePrefType | purple_prefs_get_type (const char *name)
| Get pref type.
gboolean | purple_prefs_get_bool (const char *name)
| Get boolean pref value.
int | purple_prefs_get_int (const char *name)
| Get integer pref value.
const char * | purple_prefs_get_string (const char *name)
| Get string pref value.
GList * | purple_prefs_get_string_list (const char *name)
| Get string list pref value.
const char * | purple_prefs_get_path (const char *name)
| Get path pref value.
GList * | purple_prefs_get_path_list (const char *name)
| Get path list pref value.
GList * | purple_prefs_get_children_names (const char *name)
| Returns a list of children for a pref.
guint | purple_prefs_connect_callback (void *handle, const char *name, PurplePrefCallback cb, gpointer data)
| Add a callback to a pref (and its children)
void | purple_prefs_disconnect_callback (guint callback_id)
| Remove a callback to a pref.
void | purple_prefs_disconnect_by_handle (void *handle)
| Remove all pref callbacks by handle.
void | purple_prefs_trigger_callback (const char *name)
| Trigger callbacks as if the pref changed.
void | purple_prefs_trigger_callback_object (PurplePrefCallbackData *data)
| Trigger callbacks as if the pref changed, taking a PurplePrefCallbackData instead of a name.
gboolean | purple_prefs_load (void)
| Read preferences.
void | purple_prefs_update_old (void)
| Rename legacy prefs and delete some that no longer exist.

## Detailed Description

Prefs API.

Definition in file prefs.h.

## Typedef Documentation

## ◆ PurplePrefCallback

typedef void(* PurplePrefCallback) (const char *name, PurplePrefType type, gconstpointer val, gpointer data)

The type of callbacks for preference changes.

Parameters

  name | the name of the preference which has changed.
  type | the type of the preferenced named name
  val | the new value of the preferencs; should be cast to the correct type. For instance, to recover the value of a PURPLE_PREF_INT preference, use `GPOINTER_TO_INT(val)`. Alternatively, just call purple_prefs_get_int(), purple_prefs_get_string_list() etc.
  data | Arbitrary data specified when the callback was connected with purple_prefs_connect_callback().

See also
  purple_prefs_connect_callback()

Definition at line 62 of file prefs.h.

## ◆ PurplePrefCallbackData

typedef struct _PurplePrefCallbackData PurplePrefCallbackData

Opaque type to carry callback information.

Since
  2.11.0

Definition at line 70 of file prefs.h.

## ◆ PurplePrefsUiOps

typedef struct _PurplePrefsUiOps PurplePrefsUiOps

Prefs UI operations.

This allows overriding the prefs.xml storage with anything else.

Unless specified otherwise, each entry provides an implementation for the corresponding purple_prefs_* method, and disables the prefs.xml code for it. This means that to do anything useful, all the methods must be implemented.

Since
  2.11.0

Definition at line 74 of file prefs.h.

## Enumeration Type Documentation

## ◆ _PurplePrefType

enum _PurplePrefType

Preference data types.

Enumerator
PURPLE_PREF_NONE | No type.
PURPLE_PREF_BOOLEAN | Boolean.
PURPLE_PREF_INT | Integer.
PURPLE_PREF_STRING | String.
PURPLE_PREF_STRING_LIST | List of strings.
PURPLE_PREF_PATH | Path.
PURPLE_PREF_PATH_LIST | List of paths.

Definition at line 35 of file prefs.h.

## Function Documentation

## ◆ purple_prefs_add_bool()

void purple_prefs_add_bool | ( | const char * | name,
|  | gboolean | value
| ) |  |

Add a new boolean pref.

Parameters

  name | The name of the pref
  value | The initial value to set

## ◆ purple_prefs_add_int()

void purple_prefs_add_int | ( | const char * | name,
|  | int | value
| ) |  |

Add a new integer pref.

Parameters

  name | The name of the pref
  value | The initial value to set

## ◆ purple_prefs_add_none()

void purple_prefs_add_none | ( | const char * | name | ) |

Add a new typeless pref.

Parameters

  name | The name of the pref

## ◆ purple_prefs_add_path()

void purple_prefs_add_path | ( | const char * | name,
|  | const char * | value
| ) |  |

Add a new path pref.

Parameters

  name | The name of the pref
  value | The initial value to set

## ◆ purple_prefs_add_path_list()

void purple_prefs_add_path_list | ( | const char * | name,
|  | GList * | value
| ) |  |

Add a new path list pref.

Parameters

  name | The name of the pref
  value | The initial value to set

Note
  This function takes a copy of the strings in the value list. The list itself and original copies of the strings are up to the caller to free.

## ◆ purple_prefs_add_string()

void purple_prefs_add_string | ( | const char * | name,
|  | const char * | value
| ) |  |

Add a new string pref.

Parameters

  name | The name of the pref
  value | The initial value to set

## ◆ purple_prefs_add_string_list()

void purple_prefs_add_string_list | ( | const char * | name,
|  | GList * | value
| ) |  |

Add a new string list pref.

Parameters

  name | The name of the pref
  value | The initial value to set

Note
  This function takes a copy of the strings in the value list. The list itself and original copies of the strings are up to the caller to free.

## ◆ purple_prefs_connect_callback()

guint purple_prefs_connect_callback | ( | void * | handle,
|  | const char * | name,
|  | PurplePrefCallback | cb,
|  | gpointer | data
| ) |  |

Add a callback to a pref (and its children)

Parameters

  handle | The handle of the receiver.
  name | The name of the preference
  cb | The callback function
  data | The data to pass to the callback function.

Returns
  An id to disconnect the callback

See also
  purple_prefs_disconnect_callback

## ◆ purple_prefs_exists()

gboolean purple_prefs_exists | ( | const char * | name | ) |

Check if a pref exists.

Parameters

  name | The name of the pref

Returns
  TRUE if the pref exists. Otherwise FALSE.

## ◆ purple_prefs_get_bool()

gboolean purple_prefs_get_bool | ( | const char * | name | ) |

Get boolean pref value.

Parameters

  name | The name of the pref

Returns
  The value of the pref

## ◆ purple_prefs_get_children_names()

GList * purple_prefs_get_children_names | ( | const char * | name | ) |

Returns a list of children for a pref.

Parameters

  name | The parent pref

Returns
  A list of newly allocated strings denoting the names of the children. Returns `NULL` if there are no children or if pref doesn't exist. The caller must free all the strings and the list.

Since
  2.1.0

## ◆ purple_prefs_get_handle()

void * purple_prefs_get_handle | ( | void |  | ) |

Returns the prefs subsystem handle.

Returns
  The prefs subsystem handle.

## ◆ purple_prefs_get_int()

int purple_prefs_get_int | ( | const char * | name | ) |

Get integer pref value.

Parameters

  name | The name of the pref

Returns
  The value of the pref

## ◆ purple_prefs_get_path()

const char * purple_prefs_get_path | ( | const char * | name | ) |

Get path pref value.

Parameters

  name | The name of the pref

Returns
  The value of the pref

## ◆ purple_prefs_get_path_list()

GList * purple_prefs_get_path_list | ( | const char * | name | ) |

Get path list pref value.

Parameters

  name | The name of the pref

Returns
  The value of the pref

## ◆ purple_prefs_get_string()

const char * purple_prefs_get_string | ( | const char * | name | ) |

Get string pref value.

Parameters

  name | The name of the pref

Returns
  The value of the pref

## ◆ purple_prefs_get_string_list()

GList * purple_prefs_get_string_list | ( | const char * | name | ) |

Get string list pref value.

Parameters

  name | The name of the pref

Returns
  The value of the pref

## ◆ purple_prefs_get_type()

PurplePrefType purple_prefs_get_type | ( | const char * | name | ) |

Get pref type.

Parameters

  name | The name of the pref

Returns
  The type of the pref

## ◆ purple_prefs_get_ui_ops()

PurplePrefsUiOps * purple_prefs_get_ui_ops | ( | void |  | ) |

Returns the UI operations structure used for preferences.

Returns
  The UI operations structure in use.

Since
  2.11.0

## ◆ purple_prefs_remove()

void purple_prefs_remove | ( | const char * | name | ) |

Remove a pref.

Parameters

  name | The name of the pref

## ◆ purple_prefs_rename()

void purple_prefs_rename | ( | const char * | oldname,
|  | const char * | newname
| ) |  |

Rename a pref.

Parameters

  oldname | The old name of the pref
  newname | The new name for the pref

## ◆ purple_prefs_rename_boolean_toggle()

void purple_prefs_rename_boolean_toggle | ( | const char * | oldname,
|  | const char * | newname
| ) |  |

Rename a boolean pref, toggling it's value.

Parameters

  oldname | The old name of the pref
  newname | The new name for the pref

## ◆ purple_prefs_set_bool()

void purple_prefs_set_bool | ( | const char * | name,
|  | gboolean | value
| ) |  |

Set boolean pref value.

Parameters

  name | The name of the pref
  value | The value to set

## ◆ purple_prefs_set_generic()

void purple_prefs_set_generic | ( | const char * | name,
|  | gpointer | value
| ) |  |

Set raw pref value.

Parameters

  name | The name of the pref
  value | The value to set

Deprecated:
  We're not really sure what purpose this function serves, so it will be removed in 3.0.0. Preferences values set using this function aren't serialized to prefs.xml, which could be misleading. There is also no purple_prefs_get_generic, which means that if you can't really get the value (other in a connected callback). If you think you have a use for this then please let us know.

## ◆ purple_prefs_set_int()

void purple_prefs_set_int | ( | const char * | name,
|  | int | value
| ) |  |

Set integer pref value.

Parameters

  name | The name of the pref
  value | The value to set

## ◆ purple_prefs_set_path()

void purple_prefs_set_path | ( | const char * | name,
|  | const char * | value
| ) |  |

Set path pref value.

Parameters

  name | The name of the pref
  value | The value to set

## ◆ purple_prefs_set_path_list()

void purple_prefs_set_path_list | ( | const char * | name,
|  | GList * | value
| ) |  |

Set path list pref value.

Parameters

  name | The name of the pref
  value | The value to set

## ◆ purple_prefs_set_string()

void purple_prefs_set_string | ( | const char * | name,
|  | const char * | value
| ) |  |

Set string pref value.

Parameters

  name | The name of the pref
  value | The value to set

## ◆ purple_prefs_set_string_list()

void purple_prefs_set_string_list | ( | const char * | name,
|  | GList * | value
| ) |  |

Set string list pref value.

Parameters

  name | The name of the pref
  value | The value to set

## ◆ purple_prefs_set_ui_ops()

void purple_prefs_set_ui_ops | ( | PurplePrefsUiOps * | ops | ) |

Sets the UI operations structure to be used for preferences.

Parameters

  ops | The UI operations structure.

Since
  2.11.0

## ◆ purple_prefs_trigger_callback_object()

void purple_prefs_trigger_callback_object | ( | PurplePrefCallbackData * | data | ) |

Trigger callbacks as if the pref changed, taking a PurplePrefCallbackData instead of a name.

Since
  2.11.0